# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.GeminiInstanceConfig do
  @moduledoc """
  Gemini configuration.

  ## Attributes

  *   `activeQueryEnabled` (*type:* `boolean()`, *default:* `nil`) - Output only. Whether active query is enabled.
  *   `entitled` (*type:* `boolean()`, *default:* `nil`) - Output only. Whether Gemini is enabled.
  *   `flagRecommenderEnabled` (*type:* `boolean()`, *default:* `nil`) - Output only. Whether flag recommender is enabled.
  *   `googleVacuumMgmtEnabled` (*type:* `boolean()`, *default:* `nil`) - Output only. Whether vacuum management is enabled.
  *   `indexAdvisorEnabled` (*type:* `boolean()`, *default:* `nil`) - Output only. Whether index advisor is enabled.
  *   `oomSessionCancelEnabled` (*type:* `boolean()`, *default:* `nil`) - Output only. Whether oom session cancel is enabled.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :activeQueryEnabled => boolean() | nil,
          :entitled => boolean() | nil,
          :flagRecommenderEnabled => boolean() | nil,
          :googleVacuumMgmtEnabled => boolean() | nil,
          :indexAdvisorEnabled => boolean() | nil,
          :oomSessionCancelEnabled => boolean() | nil
        }

  field(:activeQueryEnabled)
  field(:entitled)
  field(:flagRecommenderEnabled)
  field(:googleVacuumMgmtEnabled)
  field(:indexAdvisorEnabled)
  field(:oomSessionCancelEnabled)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1beta4.Model.GeminiInstanceConfig do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.GeminiInstanceConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1beta4.Model.GeminiInstanceConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
