# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.ReplicationCluster do
  @moduledoc """
  Primary-DR replica pair

  ## Attributes

  *   `drReplica` (*type:* `boolean()`, *default:* `nil`) - Output only. read-only field that indicates if the replica is a dr_replica; not set for a primary.
  *   `failoverDrReplicaName` (*type:* `String.t`, *default:* `nil`) - Optional. If the instance is a primary instance, then this field identifies the disaster recovery (DR) replica. A DR replica is an optional configuration for Enterprise Plus edition instances. If the instance is a read replica, then the field is not set. Users can set this field to set a designated DR replica for a primary. Removing this field removes the DR replica.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :drReplica => boolean() | nil,
          :failoverDrReplicaName => String.t() | nil
        }

  field(:drReplica)
  field(:failoverDrReplicaName)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1beta4.Model.ReplicationCluster do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.ReplicationCluster.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1beta4.Model.ReplicationCluster do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
